//@author: antokhio
//@help: template for standard shaders
//@tags: template
//@credits: 

struct MyBuffer {
	float4 tex0;
	float4 tex1;
};
StructuredBuffer<MyBuffer> Control;
StructuredBuffer<float3> sbPos;

float4x4 tW : WORLD;
float4x4 tVP : VIEWPROJECTION;

float3 R;

struct VS_IN
{
	float4 pos : POSITION;
	float4 uv : TEXCOORD0;
	uint iid : SV_InstanceID;
};

struct VS_OUT
{
    float4 pos: SV_POSITION;
    // float4 uv: TEXCOORD0;
	float4 col: TEXCOORD1;
};

VS_OUT VS(VS_IN input)
{
    VS_OUT output = (VS_OUT)0;
    output.pos  = mul(input.pos + float4 (sbPos[input.iid], 0),mul(tW,tVP));
	// output.uv = mul(input.uv, tTex);
	output.col = Control[input.iid].tex0;
    return output;
}

float4 PS(VS_OUT input): SV_Target
{
    float4 col = input.col;
    return col;
}

technique10 Template
{
	pass P0
	{
		SetVertexShader( CompileShader( vs_4_0, VS() ) );
		SetPixelShader( CompileShader( ps_4_0, PS() ) );
	}
}




